Index: palm/trunk/UTIL/inifor/tests/test-boundaries.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-boundaries.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/test-boundaries.f90	(revision 2696)
@@ -0,0 +1,111 @@
+!> @file tests/test-boundaries.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This program tests the boundary grid mode of INIFOR's init_grid_definition()
+!> routine.
+!------------------------------------------------------------------------------!
+ PROGRAM test_boundaries
+
+    USE grid, ONLY  :  init_grid_definition
+    USE types, ONLY :  grid_definition
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), PARAMETER     ::  title = 'boundary initialization'
+    CHARACTER(LEN=20), DIMENSION(2) ::  kind_list = (/ 'boundary', 'boundary' /)
+    LOGICAL                         ::  res
+
+    INTEGER                         ::  i, nx, ny, nz
+    TYPE(grid_definition)           ::  boundary_grid
+
+    REAL ::  dx, dy, dz, lx, ly, lz, x(2), y(10), z(10)
+
+    CALL begin_test(title, res)
+
+    ! Arange
+    dx = 1e-3
+    dy = 1.0
+    dz = 10.
+    nx = 9
+    ny = 9
+    nz = 9
+    lx = 1.0
+    ly = 1e1
+    lz = 1e2
+    x =   (/ -0.5*dx, lx + 0.5*dx /)
+    y = ( (/0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0/) + 0.5 )
+    z = ( (/0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0/) + 0.5 ) * 10
+
+    DO i = 1, SIZE(kind_list)
+   
+       ! Act
+       CALL init_grid_definition(                                              &
+          kind = kind_list(i), grid = boundary_grid,                           &
+          xmin = x(i), xmax = x(i),                                            &
+          ymin =  0.5 * dy, ymax = ly - 0.5 * dy,                              &
+          zmin =  0.5 * dz, zmax = lz - 0.5 * dz,                              &
+          x0 = 0.0, y0 = 0.0, z0 = 0.0,                                        &
+          nx = 0, ny = ny, nz = nz,                                            &
+          dx = dx, dy = dy, dz = dz )
+   
+       ! Assert
+       ! asserting that grid % x has exactly two entries and that they match
+       ! expected coordinates
+       res = res .AND. assert_equal(boundary_grid % x, (/ x(i) /), 'x coordinates')
+
+       ! asserting that grid % y and % z have expected ranges and coordinates
+       res = res .AND. assert_equal( boundary_grid % y, y, 'y coordinates')
+       res = res .AND. assert_equal( boundary_grid % z, z, 'z coordinates')
+   
+       CALL fini_grid_definition(boundary_grid)
+    END DO
+
+    CALL end_test(title, res)
+
+ CONTAINS
+
+ SUBROUTINE fini_grid_definition(grid)
+    TYPE(grid_definition), INTENT(INOUT) ::  grid
+
+    DEALLOCATE( grid % x, grid % y, grid % z )
+    DEALLOCATE( grid % kk )
+    DEALLOCATE( grid % w_verti )
+
+ END SUBROUTINE fini_grid_definition
+
+ END PROGRAM test_boundaries
Index: palm/trunk/UTIL/inifor/tests/test-centre-velocities.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-centre-velocities.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/test-centre-velocities.f90	(revision 2696)
@@ -0,0 +1,77 @@
+!> @file tests/test-centre-velocites.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This program tests INIFOR's central velocity interpolation.
+!------------------------------------------------------------------------------!
+ PROGRAM test_centre_velocities
+
+    USE test_utils
+    USE transform, &
+        ONLY :  centre_velocities
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), PARAMETER ::  title = "centre velocities"
+    LOGICAL                     ::  res
+    REAL, DIMENSION(3,3,1)      ::  u_face, u_centre, u_ref
+    REAL, DIMENSION(3,3,1)      ::  v_face, v_centre, v_ref
+    INTEGER                     ::  i
+
+    CALL begin_test(title, res)
+
+    ! Arange
+    u_face = RESHAPE( (/1, 2, 3, 1, 2, 3, 1, 2, 3/), SHAPE(u_face))
+    v_face = RESHAPE( (/1, 1, 1, 2, 2, 2, 3, 3, 3/), SHAPE(v_face))
+
+    u_ref = RESHAPE( (/0.0, 1.5, 2.5, 0.0, 1.5, 2.5, 0.0, 1.5, 2.5/), SHAPE(u_ref))
+    v_ref = RESHAPE( (/0.0, 0.0, 0.0, 1.5, 1.5, 1.5, 2.5, 2.5, 2.5/), SHAPE(v_ref))
+
+    u_centre = 0.0
+    v_centre = 0.0
+
+    ! Act
+    CALL centre_velocities(u_face, v_face, u_centre, v_centre)
+
+    ! Assert that the correct central velocities u_centre and v_centre are computed.
+    DO i = 1, 3
+       res = res .AND. assert_equal(u_centre(:,i,1), u_ref(:,i,1), 'centering u')
+       res = res .AND. assert_equal(v_centre(i,:,1), v_ref(i,:,1), 'centering v')
+    END DO
+
+    CALL end_test(title, res)
+
+ END PROGRAM test_centre_velocities
Index: palm/trunk/UTIL/inifor/tests/test-grid.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-grid.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/test-grid.f90	(revision 2696)
@@ -0,0 +1,93 @@
+!> @file tests/test-grid.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This program tests the PALM grid mode of INIFOR's init_grid_definition()
+!> routine.
+!------------------------------------------------------------------------------!
+ PROGRAM test_grid
+
+    USE grid, ONLY :  grid_definition, init_grid_definition
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), PARAMETER ::  title = "grid initialization"
+    LOGICAL                     ::  res
+
+    TYPE(grid_definition) ::  mygrid
+    INTEGER               ::  i
+    INTEGER, PARAMETER    ::  nx = 9,   ny = 19,   nz = 29
+    REAL, PARAMETER       ::  lx = 100., ly = 200., lz = 300.
+    REAL, DIMENSION(0:nx) ::  x, xu
+    REAL, DIMENSION(0:ny) ::  y, yv
+    REAL, DIMENSION(0:nz) ::  z, zw
+
+    CALL begin_test(title, res)
+
+    ! Arange
+    CALL init_grid_definition('palm', grid = mygrid,                           &
+                              xmin = 0., xmax = lx,                            &
+                              ymin = 0., ymax = ly,                            &
+                              zmin = 0., zmax = lz,                            &
+                              x0 = 0.0, y0 = 0.0, z0 = 0.0,                    &
+                              nx = nx, ny = ny, nz = nz)
+
+    ! Act
+    DO i = 0, nx
+       xu(i) = real(i) / (nx+1) * lx
+       x(i)  = 0.5*mygrid%dx + xu(i)
+    END DO
+    DO i = 0, ny
+       yv(i) = real(i) / (ny+1) * ly
+       y(i)  = 0.5*mygrid%dy + yv(i)
+    END DO
+    DO i = 0, nz
+       zw(i) = real(i) / (nz+1) * lz
+       z(i)  = 0.5*mygrid%dz + zw(i)
+    END DO
+
+    ! Assert coordinates match
+    res = res .AND. assert_equal(x,      mygrid%x,  "x" )
+    res = res .AND. assert_equal(xu(1:), mygrid%xu, "xu")
+    res = res .AND. assert_equal(y,      mygrid%y,  "y" )
+    res = res .AND. assert_equal(yv(1:), mygrid%yv, "yu")
+    res = res .AND. assert_equal(z,      mygrid%z,  "z" )
+    res = res .AND. assert_equal(zw(1:), mygrid%zw, "zu")
+
+    CALL end_test(title, res)
+
+ END PROGRAM test_grid
Index: palm/trunk/UTIL/inifor/tests/test-input-files.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-input-files.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/test-input-files.f90	(revision 2696)
@@ -0,0 +1,110 @@
+!> @file tests/test-input-files.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This program tests INIFOR's timestamping used for generating input file
+!> names.
+!------------------------------------------------------------------------------!
+ PROGRAM test_input_files
+
+    USE defs,                                                                  &
+        ONLY :  PATH
+    USE grid,                                                                  & 
+        ONLY :  input_file_list
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=50)                              ::  title
+    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  file_list, ref_list
+    LOGICAL                                        ::  res
+    INTEGER                                        ::  i     
+
+    title = "input files - daylight saving to standard time"
+    CALL begin_test(title, res)
+
+    ! Arange
+    ! ...a date range that inlcudes a shift from daylight saving time to
+    ! standard time (29.10.2017). Since all time stamps in COSMO-DE input files
+    ! are in UTC, this should not the naming cadence.
+    ALLOCATE( ref_list(6) )
+    ref_list(1)  = './laf2017102823-test.nc'
+    ref_list(2)  = './laf2017102900-test.nc'
+    ref_list(3)  = './laf2017102901-test.nc'
+    ref_list(4)  = './laf2017102902-test.nc'
+    ref_list(5)  = './laf2017102903-test.nc'
+    ref_list(6)  = './laf2017102904-test.nc'
+
+    ! Act
+    CALL input_file_list(start_date_string='2017102823',                       &
+                         start_hour=0, end_hour=5, step_hour=1,                &
+                         path='./', prefix="laf", suffix='-test',              &
+                         file_list=file_list)
+
+    ! Assert
+    DO i = 1, 6
+       res = res .AND. (TRIM(ref_list(i)) .EQ. TRIM(file_list(i)))
+    END DO
+
+    DEALLOCATE( ref_list, file_list )
+    CALL end_test(title, res)
+
+
+    title = "input files - leap day"
+    CALL begin_test(title, res)
+
+    ! Arange
+    ! ...a date range that inlcudes a leap day (29. Feb. 2016) which should be
+    ! inlcuded in UTC time stamps.
+    ALLOCATE( ref_list(2) )
+    ref_list(1)  = './laf2016022823-test.nc'
+    ref_list(2)  = './laf2016022900-test.nc'
+
+    ! Act
+    CALL input_file_list(start_date_string='2016022823',                       &
+                         start_hour=0, end_hour=1, step_hour=1,                &
+                         path='./', prefix="laf", suffix='-test',              &
+                         file_list=file_list)
+
+    ! Assert
+    DO i = 1, 2
+       res = res .AND. (TRIM(ref_list(i)) .EQ. TRIM(file_list(i)))
+    END DO
+
+    DEALLOCATE( ref_list, file_list )
+    CALL end_test(title, res)
+
+ END PROGRAM test_input_files
Index: palm/trunk/UTIL/inifor/tests/test-interpolation.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-interpolation.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/test-interpolation.f90	(revision 2696)
@@ -0,0 +1,231 @@
+!> @file tests/test-interpolation.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This program tests INIFOR's horizontal interpolation.
+!------------------------------------------------------------------------------!
+ PROGRAM test_interpolation
+
+    USE grid, &
+        ONLY:  grid_definition, init_grid_definition, TO_RADIANS, TO_DEGREES, &
+               linspace, hhl
+    USE transform, &
+        ONLY:  find_horizontal_neighbours, compute_horizontal_interp_weights
+    USE test_utils
+    
+    IMPLICIT NONE
+
+!
+!------------------------------------------------------------------------------
+!- Test 1: Find neighbours
+!------------------------------------------------------------------------------
+    CHARACTER(LEN=30) ::  title = "find neighbours"
+    LOGICAL           ::  res
+
+    TYPE(grid_definition) ::  palm_grid, cosmo_grid
+    INTEGER               ::  i, j, ii_ref(0:1, 0:1, 4), jj_ref(0:1, 0:1, 4)
+    INTEGER, PARAMETER    ::  nlon=3, nlat=3, nlev=2
+    REAL                  ::  w_ref(4), lat(0:2), lon(0:2)
+
+    title = "find neighbours"
+    CALL begin_test(title, res)
+
+    ! Arange.
+    ! Make a COSMO-DE grid with just two horizotal cells/three h. points
+    PRINT *, "INIT GRID"
+
+    ! Allocate grid.hhl for use in init_grid_definition. In INIFOR, this is done
+    ! in get_netcdf_variable_2d. In this test, grid.hhl is not used and only
+    ! defined manually because it is used in init_grid_definition. 
+    ALLOCATE (hhl (nlon, nlat, nlev) )
+    hhl(:,:,:) = 0.0
+    CALL init_grid_definition('cosmo-de', grid = cosmo_grid,                   &
+                              xmin = -5.0 * TO_RADIANS, xmax = 5.5 * TO_RADIANS, &
+                              ymin = -5.0 * TO_RADIANS, ymax = 6.5 * TO_RADIANS, &
+                              zmin =  0.0, zmax = 10.0,                        &
+                              x0 = 0.0, y0 = 0.0, z0 = 0.0,                    &
+                              nx = nlon-1, ny = nlat-1, nz = nlev-1)
+
+    PRINT *, "GRID DONE"
+    PRINT *, "COSMO lats: ", cosmo_grid % lat * TO_DEGREES
+    PRINT *, "COSMO lons: ", cosmo_grid % lon * TO_DEGREES
+    
+    res = assert_equal( (/cosmo_grid%lat(0), cosmo_grid % lon(0),              &
+                          cosmo_grid%lat(2), cosmo_grid % lon(2),              &
+                          cosmo_grid%dx*TO_DEGREES, cosmo_grid%dy*TO_DEGREES/),&
+                        (/-5.0 * TO_RADIANS, -5.0 * TO_RADIANS,                &
+                           6.5 * TO_RADIANS,  5.5 * TO_RADIANS,                &
+                           5.25, 5.75 /),    &
+                        "COSMO grid coordinates" )
+    ! Define a PALM-4U grid with only one cell, i.e. four points in the
+    ! horizontal plane. The points are located at the centres of
+    ! the COSMO-DE cells.
+    CALL init_grid_definition('palm intermediate', grid = palm_grid,           &
+                              xmin = 0.0, xmax = 1.0,                          &
+                              ymin = 0.0, ymax = 1.0,                          &
+                              zmin = 0.0, zmax = 1.0,                          &
+                              x0 = 0.0, y0 = 0.0, z0 = 0.0,                    &
+                              nx = 1, ny = 1, nz = 1)
+
+    palm_grid % clon(0,0) = 0.5 * cosmo_grid % lon(0)
+    palm_grid % clat(0,0) = 0.5 * cosmo_grid % lat(0)
+    
+    palm_grid % clon(0,1) = 0.5 * cosmo_grid % lon(0)
+    palm_grid % clat(0,1) = 0.5 * cosmo_grid % lat(2)
+
+    palm_grid % clon(1,1) = 0.5 * cosmo_grid % lon(2)
+    palm_grid % clat(1,1) = 0.5 * cosmo_grid % lat(2)
+
+    palm_grid % clon(1,0) = 0.5 * cosmo_grid % lon(2)
+    palm_grid % clat(1,0) = 0.5 * cosmo_grid % lat(0)
+
+    ii_ref(0,0,:) = (/0, 0, 1, 1/)
+    jj_ref(0,0,:) = (/0, 1, 1, 0/)
+
+    ii_ref(0,1,:) = (/0, 0, 1, 1/)
+    jj_ref(0,1,:) = (/1, 2, 2, 1/)
+    
+    ii_ref(1,1,:) = (/1, 1, 2, 2/)
+    jj_ref(1,1,:) = (/1, 2, 2, 1/)
+
+    ii_ref(1,0,:) = (/1, 1, 2, 2/)
+    jj_ref(1,0,:) = (/0, 1, 1, 0/)
+
+    ! Act
+    CALL find_horizontal_neighbours(cosmo_grid % lat, cosmo_grid % lon,        &
+       cosmo_grid % dxi, cosmo_grid % dyi, palm_grid % clat, palm_grid % clon, &
+       palm_grid % ii, palm_grid % jj)
+
+    ! Assert
+    DO j = 0, 1
+    DO i = 0, 1
+       res = res .AND. ALL(palm_grid%ii(i,j,:) == ii_ref(i,j,:))
+       PRINT *, "ii     : ", palm_grid%ii(i,j,:)
+       PRINT *, "ii_ref : ", ii_ref(i,j,:), " indices match? ", res
+       res = res .AND. ALL(palm_grid%jj(i,j,:) == jj_ref(i,j,:))
+       PRINT *, "jj     : ", palm_grid%jj(i,j,:)
+       PRINT *, "jj_ref : ", jj_ref(i,j,:), " indices match? ", res
+    END DO
+    END DO
+
+    CALL end_test(title, res)
+    
+
+!
+!------------------------------------------------------------------------------
+!- Test 2: Compute weights for linear interpolation
+!------------------------------------------------------------------------------
+    title = "interpolation weights"
+    CALL begin_test(title, res)
+
+    ! Arange
+    ! defining some shorthands
+    lon(:) = cosmo_grid % lon(:)
+    lat(:) = cosmo_grid % lat(:)
+
+    ! set up PALM-4U points at 1/4 and 1/3 of the COSMO grid widths
+    palm_grid % clon(0,0) = -0.25  * (lon(1) - lon(0)) + lon(1)
+    palm_grid % clat(0,0) = -2./3. * (lat(1) - lat(0)) + lat(1)
+    
+    palm_grid % clon(0,1) = -2./3. * (lon(1) - lon(0)) + lon(1)
+    palm_grid % clat(0,1) = +0.25  * (lat(2) - lat(1)) + lat(1)
+
+    palm_grid % clon(1,1) = +0.25  * (lon(2) - lon(1)) + lon(1)
+    palm_grid % clat(1,1) = +2./3. * (lat(2) - lat(1)) + lat(1)
+
+    palm_grid % clon(1,0) = +2./3. * (lon(2) - lon(1)) + lon(1)
+    palm_grid % clat(1,0) = -0.25  * (lat(1) - lat(0)) + lat(1)
+
+    DO j = 0, 1
+    DO i = 0, 1
+       PRINT *, "PALM lon, lat: ", palm_grid % clon(i,j) * TO_DEGREES, palm_grid % clat(i,j)*TO_DEGREES
+    END DO
+    END DO
+
+    ! Act
+    CALL find_horizontal_neighbours(cosmo_grid % lat, cosmo_grid % lon,        &
+       cosmo_grid % dxi, cosmo_grid % dyi, palm_grid % clat, palm_grid % clon, &
+       palm_grid % ii, palm_grid % jj)
+
+    CALL compute_horizontal_interp_weights(cosmo_grid % lat, cosmo_grid % lon, &
+       cosmo_grid % dxi, cosmo_grid % dyi, palm_grid % clat,                   &
+       palm_grid % clon, palm_grid % ii, palm_grid % jj, palm_grid % w_horiz)
+
+    ! Assert
+    ! asserting that neighbours are still correct
+    DO j = 0, 1
+    DO i = 0, 1
+       res = res .AND. ALL(palm_grid%ii(i,j,:) == ii_ref(i,j,:))
+       PRINT *, "ii     : ", palm_grid%ii(i,j,:)
+       PRINT *, "ii_ref : ", ii_ref(i,j,:), " indices match? ", res
+       res = res .AND. ALL(palm_grid%jj(i,j,:) == jj_ref(i,j,:))
+       PRINT *, "jj     : ", palm_grid%jj(i,j,:)
+       PRINT *, "jj_ref : ", jj_ref(i,j,:), " indices match? ", res
+    END DO
+    END DO
+
+    ! asserting that all four weights equal, 0.5, 0.25, 1./6., and 1./12., resp.
+    w_ref = (/1./6., 1./12., 0.25, 0.5/)
+    res = res .AND. assert_equal(palm_grid % w_horiz(0, 0, :), w_ref(:), "weights at (0,0)")
+    !res = res .AND. palm_grid % w_horiz(0, 0, 1) == w_ref(1)
+    !res = res .AND. palm_grid % w_horiz(0, 0, 2) == w_ref(2)
+    !res = res .AND. palm_grid % w_horiz(0, 0, 3) == w_ref(3)
+    !res = res .AND. palm_grid % w_horiz(0, 0, 4) == w_ref(4)
+
+    w_ref = (/0.5, 1./6., 1./12., 0.25/)
+    res = res .AND. assert_equal(palm_grid % w_horiz(0, 1, :), w_ref(:), "weights at (0,1)")
+    !res = res .AND. palm_grid % w_horiz(0, 1, 1) == w_ref(4)
+    !res = res .AND. palm_grid % w_horiz(0, 1, 2) == w_ref(1)
+    !res = res .AND. palm_grid % w_horiz(0, 1, 3) == w_ref(2)
+    !res = res .AND. palm_grid % w_horiz(0, 1, 4) == w_ref(3)
+
+    w_ref = (/0.25, 0.5, 1./6., 1./12./)
+    res = res .AND. assert_equal(palm_grid % w_horiz(1, 1, :), w_ref(:), "weights at (1,1)")
+    !res = res .AND. palm_grid % w_horiz(1, 1, 1) == w_ref(3)
+    !res = res .AND. palm_grid % w_horiz(1, 1, 2) == w_ref(4)
+    !res = res .AND. palm_grid % w_horiz(1, 1, 3) == w_ref(1)
+    !res = res .AND. palm_grid % w_horiz(1, 1, 4) == w_ref(2)
+
+    w_ref = (/1./12., 0.25, 0.5, 1./6./)
+    res = res .AND. assert_equal(palm_grid % w_horiz(1, 0, :), w_ref(:), "weights at (1,0)")
+    !res = res .AND. palm_grid % w_horiz(1, 0, 1) == w_ref(2)
+    !res = res .AND. palm_grid % w_horiz(1, 0, 2) == w_ref(3)
+    !res = res .AND. palm_grid % w_horiz(1, 0, 3) == w_ref(4)
+    !res = res .AND. palm_grid % w_horiz(1, 0, 4) == w_ref(1)
+
+    CALL end_test(title, res)
+
+ END PROGRAM test_interpolation
Index: palm/trunk/UTIL/inifor/tests/test-prototype.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-prototype.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/test-prototype.f90	(revision 2696)
@@ -0,0 +1,60 @@
+!> @file tests/test-prototype.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This prototype test does nothing, but serves as a template for programming
+!> new INIFOR tests.
+!------------------------------------------------------------------------------!
+ PROGRAM test_prototype
+
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), PARAMETER ::  title = "Prototype"
+    LOGICAL                     ::  res
+
+    CALL begin_test(title, res)
+
+    ! Arange
+
+    ! Act
+
+    ! Assert
+
+    CALL end_test(title, res)
+
+ END PROGRAM test_prototype
Index: palm/trunk/UTIL/inifor/tests/test-transform.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-transform.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/test-transform.f90	(revision 2696)
@@ -0,0 +1,102 @@
+!> @file tests/test-transform.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This program tests INIFOR's rotated-pole coordinate transforms.
+!------------------------------------------------------------------------------!
+ PROGRAM test_transform
+
+    USE defs, ONLY :  TO_RADIANS, TO_DEGREES
+    USE grid, ONLY :  grid_definition, init_grid_definition
+    USE transform, ONLY :  phi2phirot, rla2rlarot, phirot2phi, rlarot2rla
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=30) ::  title
+    LOGICAL           ::  res
+
+    REAL, PARAMETER ::  lx = 100., ly = 200., lz = 300.
+
+    ! Angels in degrees
+    REAL ::  phi, lambda, phi_c, lambda_c, phi2, lambda2, phi_n, lambda_n
+
+    title = "rotation north-east"
+    CALL begin_test(title, res)
+    ! Arange
+    phi    = 52.5166670000000000
+    lambda = 13.3833330000000000
+
+    phi_n    =   40.
+    lambda_n = -170.
+
+    ! Act
+    phi_c     = phi2phirot(phi,   lambda, phi_n, lambda_n)
+    lambda_c  = rla2rlarot(phi,   lambda, phi_n, lambda_n, 0.)
+
+    phi2      = phirot2phi(phi_c, lambda_c, phi_n, lambda_n, 0.)
+    lambda2   = rlarot2rla(phi_c, lambda_c, phi_n, lambda_n, 0.)
+
+    ! Assert
+    res = assert_equal( (/phi, lambda/), (/phi2, lambda2/),  "rotated grid transformations" )
+    PRINT *, " Angles before transformation:  ", phi, lambda
+    PRINT *, " and after back transformation: ", phi2, lambda2
+
+    CALL end_test(title, res)
+
+    title = "rotation south-west"
+    CALL begin_test(title, res)
+    ! Arange
+    phi    = 49.
+    lambda =  9.
+
+    phi_n    =   40.
+    lambda_n = -170.
+
+    ! Act
+    phi_c     = phi2phirot(phi,   lambda, phi_n, lambda_n)
+    lambda_c  = rla2rlarot(phi,   lambda, phi_n, lambda_n, 0.)
+
+    phi2      = phirot2phi(phi_c, lambda_c, phi_n, lambda_n, 0.)
+    lambda2   = rlarot2rla(phi_c, lambda_c, phi_n, lambda_n, 0.)
+
+    ! Assert
+    res = assert_equal( (/phi, lambda/), (/phi2, lambda2/),  "rotated grid transformations" )
+    PRINT *, " Angles before transformation:  ", phi, lambda
+    PRINT *, " and after back transformation: ", phi2, lambda2
+
+    CALL end_test(title, res)
+ END PROGRAM test_transform
